/* Wingate Monitor Bot -- (c) 2001 Darcy Grexton
   Based on wgmon, (c) 1999-2001 Lucas Madar & DALnet
 */

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>

int match(mask, name)
char *mask, *name;
{
	u_char *m;
	u_char *n;
	char *ma;
	char *na;
	int wild;
	int q;

	m = (u_char *) mask;
	n = (u_char *) name;
	ma = mask;
	na = name;
	wild = 0;
	q = 0;

	while (1) {
		if (*m == '*') {
			while (*m == '*')
				m++;
			wild = 1;
			ma = (char *)m;
			na = (char *)n;
		}

		if (!*m) {
			if (!*n)
				return 0;
			for (m--; (m > (u_char *) mask) && (*m == '?'); m--) ;
			if ((*m == '*') && (m > (u_char *) mask)
			    && (m[-1] != '\\')) return 0;
			if (!wild)
				return 1;
			m = (u_char *) ma;
			n = (u_char *)++ na;
		} else if (!*n) {
			while (*m == '*')
				m++;
			return (*m != 0);
		}
		if ((*m == '\\') && ((m[1] == '*') || (m[1] == '?'))) {
			m++;
			q = 1;
		} else
			q = 0;

		if ((tolower(*m) != tolower(*n)) && ((*m != '?') || q)) {
			if (!wild)
				return 1;
			m = (u_char *) ma;
			n = (u_char *)++ na;
		} else {
			if (*m)
				m++;
			if (*n)
				n++;
		}
	}
}
